
_set_up:

;mcp4725.c,7 :: 		void set_up() {
;mcp4725.c,8 :: 		DDC4_bit=0;
	IN         R27, DDC4_bit+0
	CBR        R27, BitMask(DDC4_bit+0)
	OUT        DDC4_bit+0, R27
;mcp4725.c,9 :: 		DDC5_bit=0;
	IN         R27, DDC5_bit+0
	CBR        R27, BitMask(DDC5_bit+0)
	OUT        DDC5_bit+0, R27
;mcp4725.c,10 :: 		DDD7_bit=1;
	IN         R27, DDD7_bit+0
	SBR        R27, BitMask(DDD7_bit+0)
	OUT        DDD7_bit+0, R27
;mcp4725.c,11 :: 		PORTD7_bit=0;
	IN         R27, PORTD7_bit+0
	CBR        R27, BitMask(PORTD7_bit+0)
	OUT        PORTD7_bit+0, R27
;mcp4725.c,12 :: 		TWI_Init(100000);         // initialize TWI communication
	LDS        R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	STS        TWPS0_bit+0, R27
	LDS        R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	STS        TWPS1_bit+0, R27
	LDI        R27, 72
	STS        TWBR+0, R27
	CALL       _TWI_Init+0
;mcp4725.c,13 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_set_up0:
	DEC        R16
	BRNE       L_set_up0
	DEC        R17
	BRNE       L_set_up0
	DEC        R18
	BRNE       L_set_up0
;mcp4725.c,15 :: 		}
L_end_set_up:
	RET
; end of _set_up

_Voltage:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 8
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;mcp4725.c,16 :: 		void Voltage( unsigned int  vout)
;mcp4725.c,19 :: 		short int i=0;
;mcp4725.c,20 :: 		dato[0] =  Address;
	MOVW       R30, R28
	LDI        R27, 192
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;mcp4725.c,21 :: 		dato[1] =  DAC_value;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 64
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;mcp4725.c,22 :: 		dato[2] = (vout / 16);       // Upper data bits     (D11.D10.D9.D8.D7.D6.D5.D4)
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 4
	MOVW       R16, R2
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	ST         Z+, R16
	ST         Z+, R17
;mcp4725.c,23 :: 		dato[3] = (vout % 16) << 4;  // Lower data bits     (D3.D2.D1.D0.x.x.x.x)
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 6
	MOVW       R16, R2
	ANDI       R16, 15
	ANDI       R17, 0
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	ST         Z+, R16
	ST         Z+, R17
;mcp4725.c,24 :: 		TWI_Start();    // issue TWI start signal
	CALL       _TWI_Start+0
;mcp4725.c,25 :: 		for(i=0; i<=3; i++) {
; i start address is: 20 (R20)
	LDI        R20, 0
; i end address is: 20 (R20)
L_Voltage2:
; i start address is: 20 (R20)
	LDI        R16, 3
	CP         R16, R20
	BRGE       L__Voltage12
	JMP        L_Voltage3
L__Voltage12:
;mcp4725.c,26 :: 		TWI_Write(dato[i]);
	MOVW       R18, R28
	MOV        R16, R20
	LDI        R17, 0
	SBRC       R20, 7
	LDI        R17, 255
	LSL        R16
	ROL        R17
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	PUSH       R20
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _TWI_Write+0
	POP        R2
	POP        R3
	POP        R20
;mcp4725.c,25 :: 		for(i=0; i<=3; i++) {
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;mcp4725.c,27 :: 		}
; i end address is: 20 (R20)
	JMP        L_Voltage2
L_Voltage3:
;mcp4725.c,28 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;mcp4725.c,29 :: 		}
L_end_Voltage:
	ADIW       R28, 7
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Voltage

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;mcp4725.c,31 :: 		void main() {
;mcp4725.c,32 :: 		set_up();
	PUSH       R2
	PUSH       R3
	CALL       _set_up+0
;mcp4725.c,33 :: 		while (1)
L_main5:
;mcp4725.c,35 :: 		PORTD7_bit=~portd7_bit;
	IN         R0, PORTD7_bit+0
	LDI        R27, BitMask(PORTD7_bit+0)
	EOR        R0, R27
	OUT        PORTD7_bit+0, R0
;mcp4725.c,36 :: 		Voltage(voltios);
	LDS        R2, _voltios+0
	LDS        R3, _voltios+1
	CALL       _Voltage+0
;mcp4725.c,37 :: 		voltios=Voltios +15;
	LDS        R16, _voltios+0
	LDS        R17, _voltios+1
	MOVW       R18, R16
	SUBI       R18, 241
	SBCI       R19, 255
	STS        _voltios+0, R18
	STS        _voltios+1, R19
;mcp4725.c,38 :: 		if (voltios>4095) voltios=0;
	LDI        R16, 255
	LDI        R17, 15
	CP         R16, R18
	CPC        R17, R19
	BRLO       L__main16
	JMP        L_main7
L__main16:
	LDI        R27, 0
	STS        _voltios+0, R27
	STS        _voltios+1, R27
L_main7:
;mcp4725.c,39 :: 		Delay_ms(1000);
	LDI        R18, 82
	LDI        R17, 43
	LDI        R16, 0
L_main8:
	DEC        R16
	BRNE       L_main8
	DEC        R17
	BRNE       L_main8
	DEC        R18
	BRNE       L_main8
	NOP
	NOP
	NOP
	NOP
;mcp4725.c,40 :: 		}
	JMP        L_main5
;mcp4725.c,41 :: 		}
L_end_main:
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
